import simplejson as json
import platform, os, subprocess, sys, socket

import Config

# From http://pypi.python.org/pypi/processing/

def machine_info(return_encoded=True):
    ipaddr = socket.getaddrinfo(socket.gethostname(), None, 0, socket.SOCK_STREAM)
    ipaddr = ipaddr[0][4][0]
    name = platform.system()
    if name == 'Windows':
        from WindowsInfo import getOS, getVersion, getRam, getCpuCount
    elif name == 'Darwin':
        from MacInfo import getOS, getVersion, getRam, getCpuCount
    else:
        from LinuxInfo import getOS, getVersion, getRam, getCpuCount
    classad = {
        'type': 'machine',
        'ip': ipaddr,
        'os': getOS(),
        'os_version': str(getVersion()),
        'arch': platform.architecture()[0][:-3],
        'cores': getCpuCount(),
        'ram': getRam()
        }

    classad.update(Config.CUSTOMADS)

    if return_encoded:
        return encode(classad)
    else:
        return classad


def encode(data):
    result = ""
    try:
        result = json.dumps(data)
    except:
        print "Could not generate ClassAd string"

    return result

def decode(data):
    result = {}
    try:
        result = json.loads(data)
    except:
        print "Could not generate ClassAd dictionary"

    return result


if __name__ == '__main__':
    from pprint import pprint
    print decode(machine_info())
