import ClassAd
import Database
import Network
import Config

def handle_machine(db, ad):
    db.insert_machine(ad)

def handle_machine_status(db, ad):
    db.update_machine_status(ad.get("ip", None))

def handle_job(db, ad):
    db.insert_job(ad)  

def handle_job_status(db, ad):
    db.update_job_status(ad.get("job_id", None),
                         ad.get("status", None))

classad_handlers = {
    'machine': handle_machine,
    'machine_status': handle_machine_status,
    'job': handle_job,
    'job_status': handle_job_status
}

class ClassAdHandler(Network.ClientHandler):
    def handle(self, data):
        database = Database.Database()
        data = ClassAd.decode(data)

        ad_handler = classad_handlers.get(data['type'], False)
        if ad_handler:
            ad_handler(database, data)

        print data
        self.client.send("{'type':'ack'}")

class Collector(Network.Server):
    pass

if __name__ == "__main__":
    running = True
    while running:
        try:
            collector = Collector(Config.PORT, Config.CLIENTKEY, Config.SERVERKEY)
            running = collector.run(ClassAdHandler)
        except:
            pass
