import sys

import ClassAd
import Database

database = Database.Database()

def display_jobs(jobs):
    print "\nJobs:"
    print "=" * 72
    for job in jobs:
        print "%s\t" * 5 % (job.id,
                            job.group_id,
                            job.status,
                            job.requirements,
                            job.executable)
    print "\n"

def display_machines(machines):
    format = "%-16s|%-16s|%-11s|%-8s|%-6s|%-15s"

    print "\nMachines:"
    print "=" * 72
    print format % ("IP", "OS", "OS Version", "Arch", "Cores", "RAM")
    print '-' * 72
    for machine in machines:
        print format % (machine.ip,
                        machine.os,
                        machine.os_version,
                        machine.arch,
                        machine.cores,
                        machine.ram)
    print "\n"

display_options = {
    'jobs': display_jobs,
    'machines': display_machines
}

if __name__ == "__main__":

    if len(sys.argv) == 1:
        option = "machines"
    else:
        option = sys.argv[1]

    if option == "machines":
        display_machines(database.machines())
    elif option == "jobs":
        display_jobs(database.jobs())
