# based on http://mail.python.org/pipermail/python-list/2003-July/217062.html

import platform, os
from ctypes import *

kernel32 = windll.kernel32

class MEMORYSTATUS(Structure):
    _fields_ = [('dwLength', c_ulong),
                ('dwMemoryLoad', c_ulong),
                ('dwTotalPhys', c_ulong),
                ('dwAvailPhys', c_ulong),
                ('dwTotalPageFile', c_ulong),
                ('dwAvailPageFile', c_ulong),
                ('dwTotalVirtual', c_ulong),
                ('dwAvailVirtual', c_ulong)]

def getOS():
    return "Windows"
    
def getVersion():
    return platform.release()
    
def getCpuCount():
    num = 1
    try:
        num = int(os.environ['NUMBER_OF_PROCESSORS'])
    except (ValueError, KeyError):
        pass
        
    return num
    
def getRam():
    memoryStatus = MEMORYSTATUS()
    memoryStatus.dwLength = sizeof(MEMORYSTATUS)
    kernel32.GlobalMemoryStatus(byref(memoryStatus))
    return memoryStatus.dwTotalPhys
    
